set pagesize 50000 linesize 100 trimsp on verify off
col object_name format a30
accept FILE_NUM  prompt " FILE_NUM? "
accept BLOCK_NUM prompt "BLOCK_NUM? " 
select file_name from dba_data_files where file_id=&&FILE_NUM
union
select file_name from dba_temp_files where file_id=&&FILE_NUM-(select value from v$parameter where name='db_files');
select 
   a.object_type
  ,a.owner
  ,nvl(substr(a.object_name,1,30),'file=&&FILE_NUM  block=&&BLOCK_NUM') object_name
  ,a.subobject_name
from dba_objects a, x$bh b
where b.obj = a.data_object_id(+)
and b.file#(+) =&&FILE_NUM
and b.dbablk(+)=&&BLOCK_NUM
/
select
   a.segment_type
  ,a.owner
  ,nvl(substr(a.segment_name,1,30),'file=&&FILE_NUM  block=&&BLOCK_NUM') segment_name
from dba_extents a
where a.file_id =&&FILE_NUM
and &&BLOCK_NUM between block_id and block_id+blocks-1
/ 
exit
